import sys,os
#sys.path.append("../")
import numpy as np
from wc_common import *

def plural_to_real(plu):
	return (plu.real**2 + plu.imag**2)**0.5

base_dir = "../time_data/"

internal_sep = "\t"
external_sep = "\t"

train_data_file = open(base_dir + "train_data","r")
tmp_user_id_file = open(base_dir + "tmp_user_id","r")
user_id_file = open(base_dir + "user_id","w")
tmp_query_id_file = open(base_dir + "tmp_query_id","r")
query_id_file = open(base_dir + "query_id","w")

all_begin_time = float(sys.float_info.max)
all_end_time = 0.0

for line in train_data_file:
	arr = line.strip().split()
	begin_time = float(arr[42])
	if begin_time > all_end_time:
		all_end_time = begin_time
	if begin_time < all_begin_time:
		all_begin_time = begin_time

print all_begin_time
print all_end_time
N = 29
span = all_end_time - all_begin_time
each_span = span/N
print each_span
print "got time span"
time_span = []
for i in range(0,N):
	time_span.append(all_begin_time + each_span * i)
train_data_file.close()

train_data_file = open(base_dir + "train_data","r")
query_list = []
user_list = []
query_dwell_time_map = {}
user_dwell_time_map = {}
user_session_map = {}
user_click_map = {}
query_session_map = {}
query_click_map = {}
for line in train_data_file:
	arr = line.strip().split()
	query = arr[0]
	user_SUV = arr[41]
	begin_time = float(arr[42])
	url_list = []
	click_list = []
	click_time_list = []
	for i in range(1,11):
		url_list.append(arr[i])
	for i in range(11,21):
		click_list.append(arr[i])
	for i in range(21,31):
		click_time_list.append(arr[i])



	dwell_time_data = []
	first_click_span = 1000
	click_times = 0
	for i in range(0,len(click_list)):
		if click_list[i] == str(1): 
			click_times += 1
			fdelta = float(click_time_list[i]) - float(begin_time)
			if fdelta > 0 and fdelta < first_click_span:
				first_click_span = fdelta
			dwell_time = 1000
			for j in range(0,len(click_time_list)):
				delta = (float(click_time_list[j]) - float(click_time_list[i])) if click_list[j] == str(1) else 0
				if delta > 0 and delta < dwell_time:
					dwell_time = delta
			if dwell_time == 1000:
				dwell_time = 30
			dwell_time_data.append(dwell_time)
		elif click_list[i] == str(0):  
			dwell_time_data.append(0)
	if first_click_span == 1000:
		first_click_span = 0
	dwell_time_data.append(first_click_span)
	dwell_time_data.append(1)

	session_arr = [0] * N
	click_arr = [0] * N
	for i in range(0,N-1):
		if ((begin_time >= time_span[i]) and (begin_time <= time_span[i+1])):
			session_arr[i] += 1
			click_arr[i] += click_times
			break

	if not query_dwell_time_map.has_key(query):
		query_dwell_time_map[query] = dwell_time_data[:]
		query_session_map[query] = session_arr[:]
		query_click_map[query] = click_arr[:]
		query_list.append(query)
		
	else:
		for i in range(0,N):
			query_session_map[query][i] += session_arr[i]
			query_click_map[query][i] += click_arr[i]
		for i in range(0,len(dwell_time_data)):
			if dwell_time_data[i] != -1:
				query_dwell_time_map[query][i] += dwell_time_data[i]


	if not user_dwell_time_map.has_key(user_SUV):
		user_dwell_time_map[user_SUV] = dwell_time_data[:]
		user_session_map[user_SUV] = session_arr[:]
		user_click_map[user_SUV] = click_arr[:]
		user_list.append(user_SUV)
	else:
		for i in range(0,N):
			user_session_map[user_SUV][i] += session_arr[i]
			user_click_map[user_SUV][i] += click_arr[i]
		for i in range(0,len(dwell_time_data)):
			if dwell_time_data[i] != -1:
				user_dwell_time_map[user_SUV][i] += dwell_time_data[i] 

	if not user_session_map.has_key(user_SUV):
		user_session_map[user_SUV] = session_arr[:]



user_list.sort(comp)
#user_id_file
for i in range(0,len(user_list)):
	user = user_list[i]
	session_size = user_dwell_time_map[user][11]
	while True:
		temp_line = tmp_user_id_file.readline()
		temp_arr = temp_line.strip().split()
		if len(temp_arr) == 0:
			break
		if int(temp_arr[1]) == int(user):
			user_id_file.write(str(temp_arr[0]) + "\t"+str(user) + "\t" + str(session_size) + "\t")
			averag_dwell_time = 0
			for j in range(0,10):
				num = user_dwell_time_map[user][j]/session_size
				if j == 9:
					user_id_file.write(str(num))
				else:
					user_id_file.write(str(num) + internal_sep)
				averag_dwell_time += num
			user_id_file.write("\t"+str(averag_dwell_time/10.0)+"\t"+str(user_dwell_time_map[user][10]/session_size)+"\t")
			session_arr = []
			click_arr = []
			for i in range(0,N):
				session_arr.append(user_session_map[user][i])
				user_id_file.write(str(user_session_map[user][i])+internal_sep)
			#user_id_file.write("\t")
			for i in range(0,N):
				click_arr.append(user_click_map[user][i])
				user_id_file.write(str(user_click_map[user][i])+internal_sep)
			#user_id_file.write("\t")

			sig = np.array(session_arr)
			fft_sig = np.fft.fft(sig)/N
			for i in range(0,len(fft_sig)):
				user_id_file.write(str(plural_to_real(fft_sig[i]))+internal_sep)
			#user_id_file.write("\t")
			sig = np.array(click_arr)
			fft_sig = np.fft.fft(sig)/N
			for i in range(0,len(fft_sig)):
				user_id_file.write(str(plural_to_real(fft_sig[i]))+internal_sep)
			user_id_file.write("\n")
			break
		else:
			user_id_file.write(str(temp_arr[0])+"\t"+str(temp_arr[1])+"\t"+"0"+"\n")
user_id_file.close()
tmp_user_id_file.close()

query_list.sort(comp)
print query_list
#query_id_file
for i in range(0,len(query_list)):
	query = query_list[i]
	session_size = query_dwell_time_map[query][11]
	while True:
		temp_line = tmp_query_id_file.readline()
		temp_arr = temp_line.strip().split()
		if len(temp_arr) == 0:
			break
		if len(temp_arr) != 4:
			continue
		if int(temp_arr[1]) == int(query):
			query_id_file.write(str(temp_arr[0]) + "\t" + str(temp_arr[1]) + "\t" + str(session_size) + "\t")
			averag_dwell_time = 0
			for j in range(0,10):
				num = query_dwell_time_map[query][j]/session_size
				if j == 9:
					query_id_file.write(str(num))
				else:	
					query_id_file.write(str(num) + internal_sep)
				averag_dwell_time += num
			query_id_file.write("\t"+str(averag_dwell_time/10.0)+"\t"+str(query_dwell_time_map[query][10]/session_size)+"\t")
			session_arr = []
			click_arr = []
			for i in range(0,N):
				session_arr.append(query_session_map[query][i])
				query_id_file.write(str(query_session_map[query][i])+internal_sep)
			#query_id_file.write("\t")
			for i in range(0,N):
				click_arr.append(query_click_map[query][i])
				query_id_file.write(str(query_click_map[query][i])+internal_sep)
			#query_id_file.write("\t")

			sig = np.array(session_arr)
			fft_sig = np.fft.fft(sig)/N
			for i in range(0,len(fft_sig)):
				query_id_file.write(str(plural_to_real(fft_sig[i]))+internal_sep)
			#query_id_file.write("\t")
			sig = np.array(click_arr)
			fft_sig = np.fft.fft(sig)/N
			for i in range(0,len(fft_sig)):
				query_id_file.write(str(plural_to_real(fft_sig[i]))+internal_sep)
			query_id_file.write("\n")
			break
		else:
			query_id_file.write(str(temp_arr[0]) + "\t" + str(temp_arr[1]) + "\t" + "0" + "\n")
query_id_file.close()
tmp_query_id_file.close()
train_data_file.close()

os.system("rm " + base_dir + "tmp_query_id")
os.system("rm " + base_dir + "tmp_user_id")